#ifndef __SGE_HOST_QMASTER_H
#define __SGE_HOST_QMASTER_H
/*___INFO__MARK_BEGIN__*/
/*************************************************************************
 * 
 *  The Contents of this file are made available subject to the terms of
 *  the Sun Industry Standards Source License Version 1.2
 * 
 *  Sun Microsystems Inc., March, 2001
 * 
 * 
 *  Sun Industry Standards Source License Version 1.2
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.2 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
 * 
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 * 
 *   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 * 
 *   Copyright: 2001 by Sun Microsystems, Inc.
 * 
 *   All Rights Reserved.
 * 
 ************************************************************************/
/*___INFO__MARK_END__*/

#include "sge_gdiP.h"
#include "sge_c_gdi.h"
#include "sge_feature.h"
#include "sge_qmaster_timed_event.h"
#include "uti/sge_monitor.h"


/* funtions called via gdi and inside the qmaster */
int sge_del_host(lListElem *, lList **, char *, char *, u_long32, const lList* master_hGroup_List);

int host_spool(lList **alpp, lListElem *ep, gdi_object_t *object);

int host_mod(lList **alpp, lListElem *new_host, lListElem *ep, int add, 
             const char *ruser, const char *rhost, gdi_object_t *object, 
             int sub_command, monitoring_t *monitor);

int host_success(lListElem *ep, lListElem *old_ep, gdi_object_t *object, lList **ppList, monitoring_t *monitor);

void sge_mark_unheard(lListElem *hep, const char *target);

int sge_add_host_of_type(const char *hostname, u_long32 target, monitoring_t *monitor);

void sge_gdi_kill_exechost(char *host, sge_gdi_request *request, sge_gdi_request *answer, uid_t uid, gid_t gid, char *user, char *group);

void sge_update_load_values(char *rhost, lList *lp);

void sge_load_value_cleanup_handler(te_event_t anEvent, monitoring_t *monitor);

int sge_count_uniq_hosts(lList *ahl, lList *shl);

int sge_execd_startedup(lListElem *hep, lList **alpp, char *ruser, char *rhost, 
                        u_long32 target, monitoring_t *monitor);

u_long32 load_report_interval(lListElem *hep); 
u_long32 sge_get_max_unheard_value(void); 

void sge_change_queue_version_exechost(const char *exechost_name);

int host_notify_about_X(lListElem *host,
                        u_long32 x,
                        int tag,
                        int progname_id);

bool
host_list_add_missing_href(lList *this_list, lList **answer_list, const lList *href_list, 
                           monitoring_t *monitor);

void host_diff_projects(const lListElem *new, const lListElem *old, lList **new_prj, lList **old_prj);
void host_diff_usersets(const lListElem *new, const lListElem *old, lList **new_acl, lList **old_acl);

#endif /* __SGE_HOST_QMASTER_H */

